program checksum;
   type devicetype = (soul,iriver);
   const SoulID = 'DMP';
         iRiverID = 'IMP';
         RioVoltID = 'SP-';
   var fn1: string;
       f1: file;
       deviceID: string[7];
       ShortID: string[3];
       device: devicetype;
       csd: longint;
       b: byte absolute csd;
       csc,address: longint;
       m: 0..4095;
       bytes: 0..4096;
       filebuffer: array[0..4095] of byte;
   begin
      Writeln(#$0D#$0A'iRiver, RioVolt, Soul DMP-01 checksum calculator'#$0D#$0A+
              'Build 1.0 by Paul Maximov (pmaximov@mail.ru), 2001-2002'#$0D#$0A);
      if ParamCount=1 then
         begin
            fn1:= ParamStr(1);
            Assign(f1,fn1);
            Filemode:= 0;                {⮡ 뢠 read-only 䠩}
            Reset(f1,1);
            deviceID:='';                {⥭  7 }
            blockread(f1,filebuffer,7);
            For m:= 0 to 6 do
               deviceID:= deviceID + chr(filebuffer[m]);
            ShortID:= copy(deviceID,1,3);
            if ShortID=SoulID then
               begin
                  device:= soul;
                  Writeln(fn1+' is the firmware for Soul DMP-01');
               end
            else if ShortID=iRiverID then
               begin
                  device:= iriver;
                  Writeln(fn1+' is the firmware for iRiver '+deviceID);
               end
            else if ShortID=RioVoltID then
               begin
                  device:= iriver;
                  Writeln(fn1+' is the firmware for RioVolt '+deviceID);
               end
            else
               begin
                  close(f1);
                  Writeln('Unknown firmware format.');
                  Halt(1);
               end;
            seek(f1, $24);
            blockread(f1,csd,4);         {⥭ ஫쭮 㬬}
            Writeln('Checksum declared:   ',csd);
            csc:=0;
            address:= $28;               { 砫 訢}
            Repeat
               blockread(f1,filebuffer,sizeof(filebuffer),bytes);
               for m:= 0 to bytes-1 do
                  begin
                     if (device=soul) and (address>=$48) then
                        filebuffer[m]:= filebuffer[m] xor b;
                     csc:= csc + filebuffer[m];
                     Inc(address)
                  end;
            until bytes<sizeof(filebuffer);
            close(f1);
            Writeln('Checksum calculated: ',csc);
            if csc=csd then Writeln('All Ok')
                       else Writeln('Checksum error :(');
         end
      else Writeln('Usage:   checksum <infile>'#$0D#$0A#$0A+
                   'Example: checksum DMP-01.hex')
   end.
`