program RioVolt2Soul;
   type devicetype = (soul,iriver);
   const SoulID = 'DMP-01'#0;
         iRiverID = 'IMP-100';
   var fn1,fn2: string;
       deviceID: string[7];
       targetdevice: devicetype;
       f1,f2: file;
       m: 0..4095;
       bytes: 0..4096;
       address: longint;
       filebuffer: array[0..4095] of byte;
       b: byte;
   begin
      Writeln(#$0D#$0A'iRiver iMP-100 (RioVolt SP-100) <--> Soul DMP-01 firmware converter'#$0D#$0A+
              'Build 1.0 by Paul Maximov (pmaximov@mail.ru), 2001-2002'#$0D#$0A);
      if ParamCount=2 then
         begin
            fn1:= ParamStr(1);
            fn2:= ParamStr(2);
            Assign(f1,fn1);
            Filemode:= 0;                {⮡ 뢠 read-only 䠩}
            Reset(f1,1);
            Assign(f2,fn2);
            Rewrite(f2,1);
            blockread(f1,filebuffer,37);     {⥭  37  ( 0  36-)}
            deviceID:='';
            For m:= 0 to 6 do
               deviceID:= deviceID + chr(filebuffer[m]);
            if deviceID=SoulID then
               begin
                  targetdevice:= iriver;
                  Writeln(fn1+' is the firmware for Soul DMP-01.'#$0D#$0A+
                              'Converting to iRiver (RioVolt) firmware format. Please wait.');
                  deviceID:= iRiverID
               end
            else if deviceID=iRiverID then
               begin
                  targetdevice:= soul;
                  Writeln(fn1+' is the firmware for iRiver iMP-100 (or RioVolt SP-100).'#$0D#$0A+
                              'Converting to Soul firmware format. Please wait.');
                  deviceID:= SoulID
               end
            else
               begin
                  close(f1); close(f2);
                  Writeln('Unknown firmware format.');
                  Halt(1);
               end;
            b:= filebuffer[36];          {36-  - }
            For m:= 0 to 6 do            {  7   }
               filebuffer[m]:= ord(deviceID[m+1]);
            blockwrite(f2,filebuffer,37);    { 37 }
            address:= $25;               {HEX- ᫥饣  箬 }
            Repeat
               blockread(f1,filebuffer,sizeof(filebuffer),bytes);
               for m:= 0 to bytes-1 do
                  begin
                     if address >=$48 then filebuffer[m]:= filebuffer[m] xor b;
                     Inc(address)
                  end;
               blockwrite(f2,filebuffer,bytes)
            until bytes<sizeof(filebuffer);
            close(f1); close(f2);
         end
      else Writeln('Usage:   r2s <infile> <outfile>'#$0D#$0A#$0A+
                   'Example: r2s Imp-100.hex DMP-01.hex')
   end.
